# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free

Name:           ops4j-pax-runner
Summary:        Pax OSGi bundle runner
Url:            http://paxrunner.ops4j.org/
Version:        1.5.0
Release:        1%{?dist}
Epoch:          0
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        ops4j-pax-runner-1.5.0.tgz
# svn export http://scm.ops4j.org/repos/ops4j/qa/pax/runner-1.5.0/ ops4j-pax-runner-1.5.0
# tar czf ops4j-pax-runner-1.5.0.tgz ops4j-pax-runner-1.5.0/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml


Patch0:         ops4j-pax-runner-pom.patch
Patch1:         ops4j-pax-runner-UnsupportedBundle.patch
Patch2:         ops4j-pax-runner-UnsupportedStartLevel.patch
Patch3:         ops4j-pax-runner-Run.patch
Patch4:         ops4j-pax-runner-assembly-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  apache-commons-parent
BuildRequires:  ops4j-pax-master

BuildRequires:  apache-felix-maven-bundle-plugin
BuildRequires:  aries-testsupport

BuildRequires:  jline2
BuildRequires:  ops4j-pax-scanner
BuildRequires:  ops4j-pax-swissbox
BuildRequires:  ops4j-pax-url

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  ops4j-pax-scanner
Requires:  ops4j-pax-swissbox
Requires:  ops4j-pax-url

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Pax OSGi runner.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done
cp %{SOURCE1} settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4


%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Daggregate=true \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pax-runner-commons/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-runner-commons.pom
%add_to_maven_depmap org.ops4j.pax.runner pax-runner-commons %{version} JPP/%{name} pax-runner-commons
install -m 644 pax-runner-handler/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-runner-handler.pom
%add_to_maven_depmap org.ops4j.pax.runner pax-runner-handler %{version} JPP/%{name} pax-runner-handler
install -m 644 pax-runner-no-jcl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-runner-no-jcl.pom
%add_to_maven_depmap org.ops4j.pax.runner pax-runner-no-jcl %{version} JPP/%{name} pax-runner-no-jcl
install -m 644 pax-runner-platform-concierge/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-runner-platform-concierge.pom
%add_to_maven_depmap org.ops4j.pax.runner pax-runner-platform-concierge %{version} JPP/%{name} pax-runner-platform-concierge
install -m 644 pax-runner-platform-equinox/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-runner-platform-equinox.pom
%add_to_maven_depmap org.ops4j.pax.runner pax-runner-platform-equinox %{version} JPP/%{name} pax-runner-platform-equinox
install -m 644 pax-runner-platform-felix/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-runner-platform-felix.pom
%add_to_maven_depmap org.ops4j.pax.runner pax-runner-platform-felix %{version} JPP/%{name} pax-runner-platform-felix
install -m 644 pax-runner-platform-knopflerfish/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-runner-platform-knopflerfish.pom
%add_to_maven_depmap org.ops4j.pax.runner pax-runner-platform-knopflerfish %{version} JPP/%{name} pax-runner-platform-knopflerfish
install -m 644 pax-runner-platform/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-runner-platform.pom
%add_to_maven_depmap org.ops4j.pax.runner pax-runner-platform %{version} JPP/%{name} pax-runner-platform
install -m 644 pax-runner/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pax-runner.pom
%add_to_maven_depmap org.ops4j.pax.runner pax-runner %{version} JPP/%{name} pax-runner
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-runner.pom
%add_to_maven_depmap org.ops4j.pax runner %{version} JPP/%{name} runner


install -m 644 pax-runner-commons/target/pax-runner-commons-1.5.0.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 pax-runner-handler/target/pax-runner-handler-1.5.0.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 pax-runner-no-jcl/target/pax-runner-no-jcl-1.5.0.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 pax-runner-platform-concierge/target/pax-runner-platform-concierge-1.5.0.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 pax-runner-platform-equinox/target/pax-runner-platform-equinox-1.5.0.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 pax-runner-platform-felix/target/pax-runner-platform-felix-1.5.0.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 pax-runner-platform-knopflerfish/target/pax-runner-platform-knopflerfish-1.5.0.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 pax-runner-platform/target/pax-runner-platform-1.5.0.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 pax-runner/target/pax-runner-1.5.0.jar $RPM_BUILD_ROOT%{_javadir}/%{name}


(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Mon Jun 27 2011 Ralph Apel <r.apel at r-apel.de> 0:1.5.0-1
- First release
